unit SMTPUnit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Psock, NMsmtp, ExtCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    StatusBar1: TStatusBar;
    NMSMTP1: TNMSMTP;
    OpenDialog1: TOpenDialog;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label7: TLabel;
    Edit7: TEdit;
    ListBox1: TListBox;
    Label8: TLabel;
    Button3: TButton;
    Button4: TButton;
    Label9: TLabel;
    Memo1: TMemo;
    Button5: TButton;
    GroupBox1: TGroupBox;
    Label10: TLabel;
    Edit8: TEdit;
    Button6: TButton;
    GroupBox2: TGroupBox;
    Label11: TLabel;
    Edit9: TEdit;
    Button7: TButton;
    Memo2: TMemo;
    Label12: TLabel;
    Edit10: TEdit;
    GroupBox3: TGroupBox;
    Label13: TLabel;
    Label14: TLabel;
    Edit11: TEdit;
    Edit12: TEdit;
    RadioGroup1: TRadioGroup;
    CheckBox1: TCheckBox;
    Button8: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure NMSMTP1AttachmentNotFound(Filename: String);
    procedure NMSMTP1AuthenticationFailed(var Handled: Boolean);
    procedure NMSMTP1Connect(Sender: TObject);
    procedure NMSMTP1SendStart(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure NMSMTP1ConnectionFailed(Sender: TObject);
    procedure NMSMTP1ConnectionRequired(var Handled: Boolean);
    procedure NMSMTP1Disconnect(Sender: TObject);
    procedure NMSMTP1EncodeEnd(Filename: String);
    procedure NMSMTP1EncodeStart(Filename: String);
    procedure NMSMTP1Failure(Sender: TObject);
    procedure NMSMTP1HostResolved(Sender: TComponent);
    procedure NMSMTP1InvalidHost(var Handled: Boolean);
    procedure NMSMTP1MailListReturn(MailAddress: String);
    procedure NMSMTP1PacketSent(Sender: TObject);
    procedure NMSMTP1RecipientNotFound(Recipient: String);
    procedure NMSMTP1Status(Sender: TComponent; Status: String);
    procedure NMSMTP1Success(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if not(NMSMTP1.Connected) then
     begin
       NMSMTP1.Host:=Edit1.Text;
       NMSMTP1.Port:=StrToInt(Edit2.Text);
       NMSMTP1.UserID:=Edit3.Text;
       NMSMTP1.Connect;
     end;  
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   if NMSMTP1.Connected then
      NMSMTP1.Disconnect;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
    if  NMSMTP1.Connected then
       begin
         NMSMTP1.ClearParams:=CheckBox1.Checked;
         NMSMTP1.SubType:=mtPlain;
         case RadioGroup1.ItemIndex of
           1:NMSMTP1.EncodeType:=uuMime;
           2:NMSMTP1.EncodeType:=uuCode;
         end;
         NMSMTP1.PostMessage.FromAddress:=Edit12.Text;
         NMSMTP1.PostMessage.FromName:=Edit11.Text;
         NMSMTP1.PostMessage.ToAddress.Text:=Edit4.Text;
         NMSMTP1.PostMessage.ToCarbonCopy.Text:=Edit5.Text;
         NMSMTP1.PostMessage.ToBlindCarbonCopy.Text:=Edit6.Text;
         NMSMTP1.PostMessage.Body.Text:=Memo1.Text;
         NMSMTP1.PostMessage.Attachments.Text:=ListBox1.Items.Text;
         NMSMTP1.PostMessage.Subject:=Edit7.Text;
         NMSMTP1.PostMessage.LocalProgram:='Delphi 6.0 Example';
         NMSMTP1.PostMessage.Date:=DateToStr(Date);
         NMSMTP1.PostMessage.ReplyTo:=Edit10.Text;
         NMSMTP1.SendMail;
       end
    else
      ShowMessage('    SMTP');
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
    NMSMTP1.ClearParameters;
    Edit4.Clear;
    Edit5.Clear;
    Edit6.Clear;
    Edit7.Clear;
    Edit10.Clear;
    Memo1.Clear;
    ListBox1.Clear;
end;

procedure TForm1.NMSMTP1AttachmentNotFound(Filename: String);
begin
   ShowMessage('  '+FileName+'  .');
end;

procedure TForm1.NMSMTP1AuthenticationFailed(var Handled: Boolean);
var
  s:string;
begin
  s:=NMSMTP1.UserID;
  if InputQuery(' ','  .   : ',s) then
     begin
       NMSMTP1.UserID:=s;
       Handled:=true;
     end;  

end;

procedure TForm1.NMSMTP1Connect(Sender: TObject);
begin
   StatusBar1.SimpleText:='.';
end;

procedure TForm1.NMSMTP1SendStart(Sender: TObject);
begin
   StatusBar1.SimpleText:=' ...';
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   if OpenDialog1.Execute then
     ListBox1.Items.Add(OpenDialog1.FileName);
end;

procedure TForm1.Button6Click(Sender: TObject);
var
   TmpStr:string;
begin
   TmpStr:=Edit8.Text;
   if  NMSMTP1.Verify(TmpStr) then
       ShowMessage(' '+TmpStr+' .')
   else
       ShowMessage(' '+TmpStr+'  .')
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   ListBox1.Items.Delete(ListBox1.ItemIndex);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
   NMSMTP1.ExpandList(Edit9.Text);
end;

procedure TForm1.NMSMTP1ConnectionFailed(Sender: TObject);
begin
   ShowMessage(' .');
end;

procedure TForm1.NMSMTP1ConnectionRequired(var Handled: Boolean);
begin
  if MessageDlg('  . ?',mtConfirmation,mbOkCancel,0)=mrOk then
     begin
       Handled:=true;
       NMSMTP1.Connect;
     end;  
end;

procedure TForm1.NMSMTP1Disconnect(Sender: TObject);
begin
   If StatusBar1<>nil then
      StatusBar1.SimpleText:=' .';
end;

procedure TForm1.NMSMTP1EncodeEnd(Filename: String);
begin
   StatusBar1.SimpleText:='  '+FileName+' .';
end;

procedure TForm1.NMSMTP1EncodeStart(Filename: String);
begin
    StatusBar1.SimpleText:='  '+FileName;
end;

procedure TForm1.NMSMTP1Failure(Sender: TObject);
begin
   StatusBar1.SimpleText:='.';
end;

procedure TForm1.NMSMTP1HostResolved(Sender: TComponent);
begin
   StatusBar1.SimpleText:=' .';
end;

procedure TForm1.NMSMTP1InvalidHost(var Handled: Boolean);
var
  TmpStr:string;
begin
    if InputQuery('  .','  : ',TmpStr) then
       begin
          NMSMTP1.Host:=TmpStr;
          Handled:=true;
       end;   
end;

procedure TForm1.NMSMTP1MailListReturn(MailAddress: String);
begin
   Memo2.Lines.Add(MailAddress);
end;

procedure TForm1.NMSMTP1PacketSent(Sender: TObject);
begin
    StatusBar1.SimpleText:=' '+IntToStr(NMSMTP1.BytesSent)+'   '+IntToStr(NMSMTP1.BytesTotal);
end;

procedure TForm1.NMSMTP1RecipientNotFound(Recipient: String);
begin
    ShowMessage('  "'+Recipient+'"  !');
end;

procedure TForm1.NMSMTP1Status(Sender: TComponent; Status: String);
begin
    If StatusBar1<>nil then
      StatusBar1.SimpleText:=status;
end;

procedure TForm1.NMSMTP1Success(Sender: TObject);
begin
    StatusBar1.SimpleText:=' .';
end;

end.
